import java.rmi.*;

public class Client {

    public static void main(String args[])
    {
	DNS dns = null;

	// Analyse des paramètres de la ligne de commande
	if (args.length < 2)
	    {
		System.err.println("Usage:");
		System.err.println("java Client <serveur> <nom_machine>");
		System.exit(1);
	    }

	// Création et installation d'un "security manager".
	System.setSecurityManager(new RMISecurityManager());

	// Obtention d'une référence du DNS (le serveur)
	try {
	    String url = new String("//"+args[0]+"/DNSGTR");
	    System.out.println("Client: lookup serveur, url = "+url);
	    dns = (DNS)Naming.lookup(url);
	}
	catch (Exception e)
	    {
		System.out.println("Erreur dans l'obtention du serveur"+e);
	    }

	// On effectue quelques lookups
	try {
	    System.out.println("L'adresse IP de \""+args[1]+"\" est "+dns.rechercher(args[1]));
	}
	catch (Exception e)
	    {
		System.out.println("Erreur de transaction pour "+args[1]);
	    }

	System.exit(0);
    }
    
}
