import java.rmi.*;

public class Serveur {

    public static void main(String args[])
    {
	// Création et installation d'un "security manager".
	System.setSecurityManager(new RMISecurityManager());

	try {
	    // Création d'une instance de notre classe DNS
	    DNS dns = new DNSImpl();
	    System.out.println("DNS créé");

	    // "Bind" de cette instance dans le RMI registry
	    Naming.rebind("DNSGTR",dns);
	    System.out.println("DNS enregistré dans le RMI registry");

	    // Ajout de quelques entrées
	    dns.enregistrer(new AdresseIPImpl(193,55,221,190), "bodega");
	    dns.enregistrer(new AdresseIPImpl(193,55,221,48), "lia");
	    dns.enregistrer(new AdresseIPImpl(193,55,221,155), "marsan");
	    dns.enregistrer(new AdresseIPImpl(193,55,221,150), "pikachu");

	    System.out.println("Le serveur est prêt...");
	}
	catch (Exception e)
	    {
		System.out.println("Il y a eu une erreur !!!");
		e.printStackTrace();
		System.out.println(e.getMessage());
	    }
    }
    
}
