import java.rmi.*;

public class Client {

    public static void main(String args[])
    {
	Distributeur distrib = null;

	// Analyse des paramètres de la ligne de commande
	if (args.length < 1)
	    {
		System.err.println("Usage:");
		System.err.println("java Client <serveur>");
		System.exit(1);
	    }

	// Création et installation d'un "security manager".
	System.setSecurityManager(new RMISecurityManager());

	// Obtention d'une référence du distributeur (le serveur)
	try {
	    String url = new String("//"+args[0]+"/DistributeurGTR");
	    System.out.println("Client: lookup serveur, url = "+url);
	    distrib = (Distributeur)Naming.lookup(url);
	}
	catch (Exception e)
	    {
		System.out.println("Erreur dans l'obtention du serveur"+e);
	    }

	// On essaye d'obtenir un ticket
	try {
	    System.out.println("Obtention du ticket n°"+distrib.prendreTicket());
	}
	catch (Exception e)
	    {
		System.out.println("Erreur de transaction pour "+args[1]);
	    }

	System.exit(0);
    }
    
}
