import java.lang.*;
import java.util.*;

import java.rmi.*;
import java.rmi.server.*;

public class BanqueImpl extends UnicastRemoteObject implements Banque 
{
    // Attributs 
    private Hashtable<String, CompteImpl> _comptes = null;

    // Constructeurs 
    public BanqueImpl() throws java.rmi.RemoteException
    {
        _comptes = new Hashtable<String, CompteImpl>();
    }

    // Méthodes de l'interface
    public boolean existe(String nom) throws java.rmi.RemoteException{
        return ((Compte)_comptes.get(nom) != null);
    }

    public void ouvrir(String nom) throws java.rmi.RemoteException{
        _comptes.put(nom, new CompteImpl(nom));
    }

    public double solde(String nom) throws java.rmi.RemoteException{
        return ((Compte)_comptes.get(nom)).solde();
    }

    public void deposer(String nom, double montant) throws java.rmi.RemoteException{
        ((Compte)_comptes.get(nom)).deposer(montant);
    }

    public void retirer(String nom, double montant) throws java.rmi.RemoteException{
        ((Compte)_comptes.get(nom)).retirer(montant);
    }

    public void transferer(String compte1, String compte2, double montant) throws java.rmi.RemoteException{
        ((Compte)_comptes.get(compte1)).retirer(montant);
        ((Compte)_comptes.get(compte2)).deposer(montant);
    }

}
