import java.rmi.*;

public class Client {
    
    public static void main(String args[])
    {
        Banque bank = null;
        // Analyse des paramétres de la ligne de commande 
        if(args.length < 2)
        {
            System.err.println("Usage:");
            System.err.println("java Client <serveur> <nom compte>");
            System.exit(1);
        }

        // Création et installation d'un "security manager"
        System.setSecurityManager(new RMISecurityManager());

        // Obtention d'une référence de la banque (le serveur)
        try{
            String url = new String("rmi://" + args[0] + ":1099/banqueGTR");
            System.out.println("Client: lookup serveur, url = " + url);
            bank = (Banque)Naming.lookup(url);
        }
        catch(Exception e)
        {
            System.out.println("Erreur dans l'obtention du serveur" + e);
        }

        // On effectue quelques transactions bancaires
        try{
System.out.println(java.net.InetAddress.getLocalHost());
            // Si la compte n'existe pas, on l'ouvre
            if (!bank.existe(args[1]))
            {
                 bank.ouvrir(args[1]);
                 System.out.println("Compte \"" + args[1] + "\" créé");
            }
            System.out.println("Le solde du compte \"" + args[1] + "\" est de " + bank.solde(args[1]) + " EUR");

            bank.deposer(args[1], 5000);
            System.out.println("Ajout de 5000 EUR sur le compte \"" + args[1] + "\"");
            System.out.println("Le solde du compte \"" + args[1] + "\" est de " + bank.solde(args[1]) + " EUR");

            bank.retirer(args[1], 400);
            System.out.println("Retrait de 400 EUR depuis le compte \"" + args[1] + "\"");
            System.out.println("Le solde du compte \"" + args[1] + "\" est de " + bank.solde(args[1]) + " EUR");

        }
        catch(Exception e)
        {
            System.out.println("Erreur dans la transaction XXXX " + args[1]);
//            e.printStackTrace();
         System.out.println(e.getMessage());
        }

    }

}
