import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

//=================================================
// L'exemple montre comment vous pourriez utiliser les manager layout: 
// BorderLayout et FlowLayout
//=================================================
public class fenetre1BFL {

   public static void main(String args[]){

      // Créer un objet de type frame, c'est la fenêtre affiché. 
      JFrame _fenetre = new JFrame("Convertisseur");

      // Fixer la Taille de la fenêtre. Paramètres: (pointX, pointY, largeur, hauteur)
     _fenetre.setBounds(200, 200, 300, 150);
      
      // Créer des composants 
      JLabel _lblTitre = new JLabel("Conversion euro => FF");
      JLabel _lblMont = new JLabel("Montant");
      JButton _btnConvertir = new JButton("Convertir");
      JButton _btnQuitter = new JButton("Quitter");
      JTextField _txtMontant = new JTextField(10);
      JTextField _txtResultat = new JTextField(20);
      _txtResultat.setEditable(false); // Composant utilisé pour montrer le résultat, par ça c'est pas modifiable
      
//=============================================
// IMPORTANT: Par défaut, le manager layout d'un panel est de type FlowLayout, c'est-à-dire, les composants ajoutés seront montrés l'un après l'autre. Si vous avez besoin de changer ce manager layout par défaut, vous devez appeler la méthode "setLayout" de l'objet panel et donner par paramètre un objet Layout 
//=============================================
      // Premier objet panel, c'est le container qui ajoute le label "Montant" et le textField pour taper le montant
      JPanel _plnCentre = new JPanel();
      _plnCentre.add(_lblMont);
      _plnCentre.add(_txtMontant);

      // Deuxième objet panel, c'est le container qui ajoute les deux  button "Convertir" et "Quitter", et le textField pour afficher le résultat
      JPanel _plnSouth = new JPanel();
      // IMPORTANT: Je change le manager layout par défaut du panel à BorderLayout. 
      _plnSouth.setLayout(new BorderLayout());      
      _plnSouth.add(_btnConvertir, BorderLayout.WEST); //Button "Convertir" à gauche du panel
      _plnSouth.add(_btnQuitter, BorderLayout.EAST); //Button "Quitter" à droite du panel
      _plnSouth.add(_txtResultat, BorderLayout.SOUTH); //TextField "Résultat" au sud du panel

//=============================================
// IMPORTANT: Par défaut, le manager layout d'un frame est de type BorderLayout, c'est-à-dire, les composants pouvent être affichés en cinq places seulement: NORTH, SOUTH, CENTRE, WEST, EAST. Si vous avez besoin de changer ce manager layout par défaut, vous devez appeler la méthode "setLayout" de l'objet panel et donner par paramètre un objet Layout.
//=============================================
      // Le composant label "Conversion euro => FF" est ajouté au Nord de la fenêtre
      _fenetre.add(_lblTitre, BorderLayout.NORTH);

      // Le premier panel est ajouté au centre de la fenêtre
      _fenetre.add(_plnCentre, BorderLayout.CENTER);

      // Le deuxième panel est ajouté au sud de la fenêtre

      _fenetre.add(_plnSouth, BorderLayout.SOUTH);


      // La méthode "pack" redimensionne la taille de la fenêtre que vous avez donné (setBounds ou setSize), à ajuster la fenêtre à une taille juste pour les composants
      _fenetre.pack();

//=============================================
// IMPORTANT: Si vous avez regarde bien, quand je ferme la fenêtre le programme continue à marcher. Il faut appeler "setDefaultCloseOperation" pour indiquer que chaque fois que je ferme la fenêtre le programme dois arrêter.
//=============================================
      _fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      // J'affiche la fenêtre. La méthode "setVisible" remplace la méthode "show" (méthode obsolète)
      _fenetre.setVisible(true); // _fenetre.show();
      
    }

}

