import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

//=================================================
// L'exemple montre comment vous pourriez utiliser le manager layout: 
// GridLayout
//=================================================
public class fenetre2GL {

   public static void main(String args[]){

      // Créer un objet de type frame, c'est la fenêtre affiché. 
      JFrame _fenetre = new JFrame("Convertisseur");

      // Fixer la Taille de la fenêtre. Paramètres: (pointX, pointY, largeur, hauteur)
     _fenetre.setBounds(200, 200, 300, 130);
      
      // Créer des composants 
      JLabel _lblTitre = new JLabel("Conversion euro => FF");
      JLabel _lblMont = new JLabel("Montant");
      JButton _btnConvertir = new JButton("Convertir");
      JButton _btnQuitter = new JButton("Quitter");
      JTextField _txtMontant = new JTextField(10);
      JTextField _txtResultat = new JTextField(20);
      _txtResultat.setEditable(false); // Composant utilisé pour montrer le résultat, par ça c'est pas modifiable
      
//=================================================
// IMPORTANT: Par défaut, le manager layout d'un panel est de type FlowLayout, c'est-à-dire, les composants ajoutés seront montrés l'un après l'autre. Si vous avez besoin de changer ce manager layout par défaut, vous devez appeler la méthode "setLayout" de l'objet panel et donner par paramètre un objet Layout 
//=================================================
      // Premier objet panel, c'est le container qui ajoute le label "Montant" et le textField pour taper le montant
      JPanel _plnCentre = new JPanel();
      _plnCentre.add(_lblMont);
      _plnCentre.add(_txtMontant);

      // Deuxième objet panel, c'est le container qui ajoute les deux  button "Convertir" et "Quitter", et le textField pour afficher le résultat
      JPanel _plnSouth = new JPanel();

//=================================================
// IMPORTANT: Je change le manager layout par défaut du panel  à GridLayout.
//=================================================
      _plnSouth.setLayout(new GridLayout(2, 0)); // 2 lignes, et les colonnes son calculés selon le nombre de composants. Si j'utilise "new GridLayout(3,4)", c'est 3 lignes est les colonnes sont toujours calculés. Et si je mets "new GridLayout(0,4)", c'est 4 colonnes et les lignes sont calculés. 
      _plnSouth.add(_btnConvertir); // Premier Ligne
      _plnSouth.add(_btnQuitter); // Premier ligne et deuxième colonne qui est calculé à partir du nombre de composants
      _plnSouth.add(_txtResultat);  // Deuxième Ligne

//=================================================
// IMPORTANT: Par défaut, le manager layout d'un frame est de type BorderLayout, c'est-à-dire, les composants pouvent être affichés en cinq places seulement: NORTH, SOUTH, CENTRE, WEST, EAST. Si vous avez besoin de changer ce manager layout par défaut, vous devez appeler la méthode "setLayout" de l'objet panel et donner par paramètre un objet Layout.
//=================================================

//=================================================
// IMPORTANT: Je change le manager layout par défaut du frame à GridLayout. 
//=================================================
      _fenetre.setLayout(new GridLayout(3, 0)); // 3 lignes, et les colonnes son calculés 

      // Le composant label "Conversion euro => FF" est ajouté à la premier ligne de la grille
      _fenetre.add(_lblTitre);

      // Le premier panel est ajouté à la deuxième ligne de la grille
      _fenetre.add(_plnCentre);

      // Le deuxième panel est ajouté à la troisième ligne de la grille
      _fenetre.add(_plnSouth);


      // La méthode "pack" redimensionne la taille de la fenêtre que vous avez donné (setBounds ou setSize), à ajuster la fenêtre à une taille juste pour les composants
      //_fenetre.pack();

//=================================================
// IMPORTANT: Si vous avez regarde bien, quand je ferme la fenêtre le programme continue à marcher. Il faut appeler "setDefaultCloseOperation" pour indiquer que chaque fois que je ferme la fenêtre le programme dois arrêter.
//=================================================
      _fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      // J'affiche la fenêtre. La méthode "setVisible" remplace la méthode "show" (méthode obsolète)
      _fenetre.setVisible(true); // _fenetre.show();
      
    }

}
