import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class EcouteurKey extends KeyAdapter
{
   // Attributs temporels 
   JFrame _tmpFenetre;
   JTextField _tmpMontant;
   JTextField _tmpResultat;

   // Les constructeurs pour les passer les composont de l'autre classe
   public EcouteurKey(JFrame _fen, JTextField _mont, JTextField _resultat)
   {
        // Remplacer les attributs temporels pour lequels qui viennent par paramètres 
        _tmpFenetre = _fen;
        _tmpMontant = _mont;
        _tmpResultat = _resultat;
   }

//=============================================
// La méthode de la classe KeyAdapter qui implemente l'interface KeyListener
//=============================================
   public void keyReleased(KeyEvent e) 
   {
      try
      {
          if(e.getKeyCode() != KeyEvent.VK_ESCAPE )
             convertir(); // la méthode ci-dessous 
          else
             // Si l'utilisateur appuye la touche ESC le programme génére une exception particulière
             throw new ToucheEchapException(); 
      }// fin try 
      catch(ToucheEchapException et) // je contrôle mon exception
      {System.out.println(et.getMessage());}
      catch(NumberFormatException nex)
      {System.out.println("Le format du numèro est incorrecte!!");}
      catch(Exception ex)
      {System.out.println("Erreur: " + ex.getMessage());}
   }

//=============================================
// Les méthodes de la classe pour faire les opérations demandés 
// Ces méthodes utilisent les composent temporels (qui ont été remplacés par les originaux dans le constructeur)
//=============================================
   private void convertir()
   {
         String _montant = _tmpMontant.getText().trim();
         if(!_montant.equals("") && _montant != null)
	 {
	     double result = (6.56 * Double.parseDouble(_montant));
             //========= Version 1 ============
             System.out.println("Vous avez obtenu: "+ result +"FF");

             //========= Version 2 ============
             JDialog d = new JDialog(_tmpFenetre, "Resultat", true);
             d.getContentPane().add(new JLabel("Vous avez obtenu: "+ result +"FF"), BorderLayout.NORTH);
             d.setLocationRelativeTo(_tmpFenetre);
             d.pack();
             d.setVisible(true);

             //========= Version 3 ============
             _tmpResultat.setText("Vous avez obtenu: "+ result +"FF");
         }// fin if
         else
             System.out.println("Vous devez taper un numèro!!");
   }

}
