import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

//=================================================
// L'exemple montre comment vous pourriez implementer les écouteurs. 
// Solution 1: Dedans de la même classe
//=================================================
public class fenetreSol1 extends JFrame
    implements ActionListener, KeyListener{


   private JLabel _lblTitre = new JLabel("Conversion euro => FF");
   private JLabel _lblMont = new JLabel("Montant");
   private JButton _btnConvertir = new JButton("Convertir");
   private JButton _btnQuitter = new JButton("Quitter");
   private JTextField _txtMontant = new JTextField(10);
   private JTextField _txtResultat = new JTextField(20);

   public fenetreSol1(String titre)
   {
      //=============================================
      //================ LES WIDGETS ==============
      //=============================================
      super(titre);
      setBounds(200, 200, 350, 200);
      _txtResultat.setEditable(false);       

      setLayout(new GridBagLayout());
      GridBagConstraints constraint = new GridBagConstraints(); 

      constraint.gridx = 0;
      constraint.gridy = 2;
      constraint.weightx = 0.5;
      constraint.insets = new Insets(10, 10, 5, 10);
      constraint.anchor = GridBagConstraints.EAST;
      add(_lblMont, constraint); // Ajouter le composant et la contrainte

      constraint.gridx = 1;
      constraint.gridy = 2;
      constraint.anchor = GridBagConstraints.WEST;
      constraint.fill = GridBagConstraints.HORIZONTAL;
      add(_txtMontant, constraint);

      constraint.gridx = 0;
      constraint.gridy = 3;
      constraint.insets = new Insets(5,10,10,10);
      constraint.anchor = GridBagConstraints.EAST;
      constraint.fill = GridBagConstraints.NONE;
      constraint.ipady = 10;
      add(_btnConvertir, constraint);

      constraint.gridx = 1;
      constraint.gridy = 3;
      constraint.anchor = GridBagConstraints.WEST;
      constraint.fill = GridBagConstraints.NONE;
      add(_btnQuitter, constraint);

      constraint.gridx = 0;
      constraint.gridy = 4;
      constraint.gridwidth = 2;
      constraint.weightx = 1;
      constraint.weighty = 0.5;
      constraint.insets = new Insets(5,5,5,5);
      constraint.anchor = GridBagConstraints.PAGE_END;
      constraint.fill = GridBagConstraints.VERTICAL;
      constraint.ipadx = 60;
      constraint.ipady = 0;
      add(_txtResultat, constraint);


      constraint.gridx = 0;
      constraint.gridy = 0;
      constraint.gridwidth = 2;
      constraint.gridheight = 2;
      constraint.weightx = 0.5;
      constraint.weighty = 0.5;
      constraint.insets = new Insets(0,0,0,0);
      constraint.anchor = GridBagConstraints.CENTER;
      constraint.fill = GridBagConstraints.NONE;
      constraint.ipadx = 0;
      constraint.ipady = 0;

      add(_lblTitre, constraint);


      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      setVisible(true); 

      //=============================================
      //================ LES ECOUTEURS ==============
      //=============================================
      //========= Version 1,2,3 (TP2) ============
      _btnQuitter.setActionCommand("quitter"); // "quitter" est le nom de la commande 
      _btnQuitter.addActionListener(this); // "this" est la classe fenetreSol1 qui implemente l'interface ActionListener
      _btnConvertir.setActionCommand("convertir");
      _btnConvertir.addActionListener(this);
      _txtMontant.setActionCommand("montant");
      _txtMontant.addActionListener(this); // "this" est la classe fenetreSol1 qui implemente l'interface KeyListener
 
      //========= Version 4 (TP2) ============
      _txtMontant.addKeyListener(this); // "this" est la classe fenetreSol1 qui implemente l'interface KeyListener

   }//fin constructeur

//=============================================
//=== LES MÉTHODES DE L'INTERFACE xxxxLISTENER 
//=============================================
   // La méthode de l'interface ActionListener
   public void actionPerformed(ActionEvent e)
   {
      String _strCommande =  e.getActionCommand();
      if (_strCommande.equals("quitter"))
      {
          this.quitter(); // la méthode ci-dessous 
      }
      else if(_strCommande.equals("convertir") || _strCommande.equals("montant") )
      {
          this.convertir(); // la méthode ci-dessous 
      }
   }

   // La méthode de la classe KeyAdapter qui implemente l'interface KeyListener
   public void keyReleased(KeyEvent e)
   {
      if(e.getKeyCode() != KeyEvent.VK_ESCAPE )
      {
          this.convertir(); // la méthode ci-dessous 
      }
   }

   // Les autres méthodes sont implementés, ils sont vides, parce que Java demande que toutes les méthodes d'une interface doivent être implementés.
   public void keyPressed(KeyEvent e){}
   public void keyTyped(KeyEvent e){}

//=============================================
// Les méthodes de la classe pour faire les opérations demandés  
//=============================================
   private void quitter()
   {
      this.dispose();
      this.setVisible(false);
   }

   private void convertir()
   {
      try{
         String _montant = _txtMontant.getText().trim();
         if(!_montant.equals("") && _montant != null)
	 {
	     double result = (6.56 * Double.parseDouble(_montant));
             //========= Version 1 ============
             System.out.println("Vous avez obtenu: "+ result +"FF");

             //========= Version 2 ============
             JDialog d = new JDialog(this, "Resultat", true);
             d.getContentPane().add(new JLabel("Vous avez obtenu: "+ result +"FF"), BorderLayout.NORTH);
             d.setLocationRelativeTo(this);
             d.pack();
             d.setVisible(true);

             //========= Version 3 ============
             _txtResultat.setText("Vous avez obtenu: "+ result +"FF");
         }// fin if
         else
             System.out.println("Vous devez taper un numèro!!");
      }// fin try 
      catch(NumberFormatException nex)
      {System.out.println("Le format du numèro est incorrecte!!");}
      catch(Exception ex)
      {System.out.println("Erreur: " + ex.getMessage());}
   }

//=============================================
//========== Pour éxecuter la classe ==========
//=============================================
   public static void main(String args[]){
      JFrame _fenetre = new fenetreSol1("Convertisseur");
    }


}
