import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

//=================================================
// L'exemple montre comment vous pourriez implementer les écouteurs. 
// Solution 3: classes internes ANONYME
//=================================================
public class fenetreSol3 extends JFrame {


   private JLabel _lblTitre = new JLabel("Conversion euro => FF");
   private JLabel _lblMont = new JLabel("Montant");
   private JButton _btnConvertir = new JButton("Convertir");
   private JButton _btnQuitter = new JButton("Quitter");
   private JTextField _txtMontant = new JTextField(10);
   private JTextField _txtResultat = new JTextField(20);

   public fenetreSol3(String titre)
   {
      //=============================================
      //================ LES WIDGETS ==============
      //=============================================
      super(titre);
      setBounds(200, 200, 350, 200);
      _txtResultat.setEditable(false);       

      setLayout(new GridBagLayout());
      GridBagConstraints constraint = new GridBagConstraints(); 

      constraint.gridx = 0;
      constraint.gridy = 2;
      constraint.weightx = 0.5;
      constraint.insets = new Insets(10, 10, 5, 10);
      constraint.anchor = GridBagConstraints.EAST;
      add(_lblMont, constraint); // Ajouter le composant et la contrainte

      constraint.gridx = 1;
      constraint.gridy = 2;
      constraint.anchor = GridBagConstraints.WEST;
      constraint.fill = GridBagConstraints.HORIZONTAL;
      add(_txtMontant, constraint);

      constraint.gridx = 0;
      constraint.gridy = 3;
      constraint.insets = new Insets(5,10,10,10);
      constraint.anchor = GridBagConstraints.EAST;
      constraint.fill = GridBagConstraints.NONE;
      constraint.ipady = 10;
      add(_btnConvertir, constraint);

      constraint.gridx = 1;
      constraint.gridy = 3;
      constraint.anchor = GridBagConstraints.WEST;
      constraint.fill = GridBagConstraints.NONE;
      add(_btnQuitter, constraint);

      constraint.gridx = 0;
      constraint.gridy = 4;
      constraint.gridwidth = 2;
      constraint.weightx = 1;
      constraint.weighty = 0.5;
      constraint.insets = new Insets(5,5,5,5);
      constraint.anchor = GridBagConstraints.PAGE_END;
      constraint.fill = GridBagConstraints.VERTICAL;
      constraint.ipadx = 60;
      constraint.ipady = 0;
      add(_txtResultat, constraint);


      constraint.gridx = 0;
      constraint.gridy = 0;
      constraint.gridwidth = 2;
      constraint.gridheight = 2;
      constraint.weightx = 0.5;
      constraint.weighty = 0.5;
      constraint.insets = new Insets(0,0,0,0);
      constraint.anchor = GridBagConstraints.CENTER;
      constraint.fill = GridBagConstraints.NONE;
      constraint.ipadx = 0;
      constraint.ipady = 0;

      add(_lblTitre, constraint);


      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      setVisible(true); 

      //=============================================
      //================ LES ECOUTEURS ==============
      //====== CLASSES INTERNES ANONYMES ============
      //=============================================
      //========= Version 1,2,3 (TP2) ============

      // Classe anonyme qui implemente l'interface ACTIONLISTENER sur le boutton "Quitter" 
      _btnQuitter.addActionListener(new ActionListener() {
           public void actionPerformed(ActionEvent e)
           {
               quitter(); // la méthode ci-dessous 
           }
       }
      ); 

      // Classe anonyme qui implemente l'interface ACTIONLISTENER sur le boutton "Convertir" 
      _btnConvertir.addActionListener(new ActionListener() {
           public void actionPerformed(ActionEvent e)
           {
               convertir(); // la méthode ci-dessous 
           }
       }
      );

      // Classe anonyme qui implemente l'interface ACTIONLISTENER sur le textField quand on appuye la touche "Entrée" 
      _txtMontant.addActionListener(new ActionListener() {
           public void actionPerformed(ActionEvent e)
           {
               convertir(); // la méthode ci-dessous 
           }
       }
      );
 
      //========= Version 4 (TP2) ============
      // Classe anonyme qui implemente l'interface KEYLISTENER à travers de la classe KEYADAPTER (pour éviter redéfinir toutes les méthodes de l'interface précedente) sur le textField quand on tape un caractère
      _txtMontant.addKeyListener(new KeyAdapter() {
           public void keyReleased(KeyEvent e)
           {
               if(e.getKeyCode() != KeyEvent.VK_ESCAPE )
               {
                   convertir(); // la méthode ci-dessous 
               }
           }
       }
      );

   }//fin constructeur

//=============================================
// Les méthodes de la classe pour faire les opérations demandés 
//=============================================
   private void quitter()
   {
      this.dispose();
      this.setVisible(false);
   }

   private void convertir()
   {
      try{
         String _montant = _txtMontant.getText().trim();
         if(!_montant.equals("") && _montant != null)
	 {
	     double result = (6.56 * Double.parseDouble(_montant));
             //========= Version 1 ============
             System.out.println("Vous avez obtenu: "+ result +"FF");

             //========= Version 2 ============
             JDialog d = new JDialog(this, "Resultat", true);
             d.getContentPane().add(new JLabel("Vous avez obtenu: "+ result +"FF"), BorderLayout.NORTH);
             d.setLocationRelativeTo(this);
             d.pack();
             d.setVisible(true);

             //========= Version 3 ============
             _txtResultat.setText("Vous avez obtenu: "+ result +"FF");
         }// fin if
         else
             System.out.println("Vous devez taper un numèro!!");
      }// fin try 
      catch(NumberFormatException nex)
      {System.out.println("Le format du numèro est incorrecte!!");}
      catch(Exception ex)
      {System.out.println("Erreur: " + ex.getMessage());}
   }

//=============================================
//========= Pour éxecuter la classe ===========
//=============================================
   public static void main(String args[]){
      JFrame _fenetre = new fenetreSol3("Convertisseur");
   
    }

}
