import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

//=================================================
// L'exemple montre comment vous pourriez implementer les écouteurs. 
// Solution 4: classes EXTERNES
//=================================================
public class fenetreSol4 extends JFrame {


   private JLabel _lblTitre = new JLabel("Conversion euro => FF");
   private JLabel _lblMont = new JLabel("Montant");
   private JButton _btnConvertir = new JButton("Convertir");
   private JButton _btnQuitter = new JButton("Quitter");
   private JTextField _txtMontant = new JTextField(10);
   private JTextField _txtResultat = new JTextField(20);

   public fenetreSol4(String titre)
   {
      //=============================================
      //================ LES WIDGETS ==============
      //=============================================
      super(titre);
      setBounds(200, 200, 350, 200);
      _txtResultat.setEditable(false);       

      setLayout(new GridBagLayout());
      GridBagConstraints constraint = new GridBagConstraints(); 

      constraint.gridx = 0;
      constraint.gridy = 2;
      constraint.weightx = 0.5;
      constraint.insets = new Insets(10, 10, 5, 10);
      constraint.anchor = GridBagConstraints.EAST;
      add(_lblMont, constraint); // Ajouter le composant et la contrainte

      constraint.gridx = 1;
      constraint.gridy = 2;
      constraint.anchor = GridBagConstraints.WEST;
      constraint.fill = GridBagConstraints.HORIZONTAL;
      add(_txtMontant, constraint);

      constraint.gridx = 0;
      constraint.gridy = 3;
      constraint.insets = new Insets(5,10,10,10);
      constraint.anchor = GridBagConstraints.EAST;
      constraint.fill = GridBagConstraints.NONE;
      constraint.ipady = 10;
      add(_btnConvertir, constraint);

      constraint.gridx = 1;
      constraint.gridy = 3;
      constraint.anchor = GridBagConstraints.WEST;
      constraint.fill = GridBagConstraints.NONE;
      add(_btnQuitter, constraint);

      constraint.gridx = 0;
      constraint.gridy = 4;
      constraint.gridwidth = 2;
      constraint.weightx = 1;
      constraint.weighty = 0.5;
      constraint.insets = new Insets(5,5,5,5);
      constraint.anchor = GridBagConstraints.PAGE_END;
      constraint.fill = GridBagConstraints.VERTICAL;
      constraint.ipadx = 60;
      constraint.ipady = 0;
      add(_txtResultat, constraint);


      constraint.gridx = 0;
      constraint.gridy = 0;
      constraint.gridwidth = 2;
      constraint.gridheight = 2;
      constraint.weightx = 0.5;
      constraint.weighty = 0.5;
      constraint.insets = new Insets(0,0,0,0);
      constraint.anchor = GridBagConstraints.CENTER;
      constraint.fill = GridBagConstraints.NONE;
      constraint.ipadx = 0;
      constraint.ipady = 0;

      add(_lblTitre, constraint);


      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      setVisible(true); 

      //=============================================
      //================ LES ECOUTEURS ==============
      //=============================================
      //========= Version 1,2,3 (TP2) ============
      // Une instance de la classe EXTERNE "EcouteurButton", les composont sont passé par paramètres 
      ActionListener _eB = new EcouteurButton(this, _txtMontant, _txtResultat); 
      _btnQuitter.setActionCommand("quitter"); // "quitter" est le nom de la commande 
      _btnQuitter.addActionListener(_eB); // "_eB" est un objet de la classe externe "EcouteurButton" de fenetreSol4 qui implemente l'interface ActionListener
      _btnConvertir.setActionCommand("convertir");
      _btnConvertir.addActionListener(_eB);
      _txtMontant.setActionCommand("montant");
      _txtMontant.addActionListener(_eB); 
 
      //========= Version 4 (TP2) ============
      // Une instance de la classe EXTERNE "EcouteurKey", les composont sont passé par paramètres 
      KeyListener _eK = new EcouteurKey(this, _txtMontant, _txtResultat); 
      _txtMontant.addKeyListener(_eK); // "_eK" est un objet de la classe externe "EcouteurKey" de fenetreSol4 qui étends la classe KeyAdapter

   }//fin constructeur


//=============================================
//========= Pour éxecuter la classe ===========
//=============================================
   public static void main(String args[]){
      JFrame _fenetre = new fenetreSol4("Convertisseur");
   
    }

}
