import java.rmi.*;
import java.rmi.server.*;

public class ChatClientImpl extends UnicastRemoteObject implements ChatClient
{
    // Atributs 
    private String _nom;
    private GUIClient _gui;

    // Constructeurs 
    public ChatClientImpl() throws RemoteException
    {
        _nom = "unknown";
    }

    public ChatClientImpl(String name) throws RemoteException
    {
        _nom = name;
    }


    public ChatClientImpl(String name, GUIClient gui) throws RemoteException
    {
        _nom = name;
        _gui = gui;
    }

    // Méthodes de l'interface

    public String nom() throws RemoteException
    {
        return _nom;
    }

    public void afficherMessage(Message msg) throws RemoteException
    {
        if(_gui == null){
           if (!_nom.equals(msg.origine()))
               System.out.println(msg);
        }else{
           _gui.afficherMessage(msg);
        }
    }
    
}
