import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.rmi.*;

public class GUIClientSwing extends JFrame implements GUIClient
{
    // Attributs
    private ChatRoom   _mycr; // Ajoute le ChatRoom temporel 
    private String  _myname;  // Ajoute le nom du utilisateur temporel 

    private JTextArea  _msgArea;
    private JTextField _txtField;
    private JButton _btnEnvoyer;
    private JButton _btnQuitter;

    // Constructeurs
    // Ajoute le ChatRoom au constructeur  
    public GUIClientSwing (String name, ChatRoom cr) 
    {
         super("Utilisateur: " + name);

         // Remplacer les valeurs locaux par lequels qui viennent par paramètres
         _mycr = cr;
         _myname = name;

        _msgArea = new JTextArea(25, 10);
        _msgArea.setEditable(false);
        this.add(_msgArea, BorderLayout.CENTER);

        JPanel panel = new JPanel();
        _txtField = new JTextField(20);
        _txtField.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                try{
                    // J'appelle a ChatRoom pour envoyer le message que je tape sur le composant JTextField
                    _mycr.envoyerMessage(new MessageImpl(_myname, _txtField.getText()));
                    _txtField.setText("");
                }catch(RemoteException ex){
                    _msgArea.append("\n" + "*** java.rmi.RemoteException ***" );
                    System.out.println("Erreur: " + ex.getMessage());
                    ex.printStackTrace();
                }
            }
        });
   
        _btnEnvoyer = new JButton("Envoyer");
        _btnEnvoyer.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                try{
                    // J'appelle a ChatRoom pour envoyer le message que je tape sur le composant JTextField
                    _mycr.envoyerMessage(new MessageImpl(_myname, _txtField.getText()));
                    _txtField.setText("");
                }catch(RemoteException ex){
                    _msgArea.append("\n" + "*** java.rmi.RemoteException ***" ); 
                    System.out.println("Erreur: " + ex.getMessage());
                    ex.printStackTrace();
                }
            }
        });

        _btnQuitter = new JButton("Quitter");
        _btnQuitter.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                System.exit(0);
            }
        });
        
        panel.add(_txtField);
        panel.add(_btnEnvoyer);
        panel.add(_btnQuitter);
        this.add(panel, BorderLayout.SOUTH);

	// Affichage de la fenetre
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	this.pack();
	this.setVisible(true);

  
    }//fin constructeur

    // Methodes de l'interface
    public void afficherMessage(Message msg) {
        _msgArea.append("\n" + msg.toString());
    }

}
