import java.rmi.*;
import java.io.*;

public class Client 
{
    public static void main(String args[])
    {
        ChatRoom cr = null;
        ChatClient cc = null;

        if(args.length < 2)
        {
	    System.err.println("Usage:");
	    System.err.println("java Client <serveur> <nom_utilisateur>");
	    System.exit(1);
        }
        
        // Création et installation d'un "Security Manager"
        System.setSecurityManager(new RMISecurityManager());

        // Obtention d'une référence de la ChatRoom (le serveur)
        try
        {
            String url = new String("//" + args[0] + "/ChatRoomGRT");
	    System.out.println("Client: lookup serveur, url: " + url);
            cr = (ChatRoom) Naming.lookup(url);
        }
        catch(Exception e)
        {
             System.out.println("Erreur dans l'obtention du serveur" + e);
        }

        // On effectue quelques lookups 
        try
        {
             // IMPORTANT: Je remplace la console par l'interface graphique 
             // On saisie des chaînes de caractères et on les envoie au serveur
             /*BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
             String buf;
             boolean fin = false;
             while(!fin)
             {
                 buf = in.readLine();
                 if(buf.equals(""))
                    fin = true;
                 else
                    cr.envoyerMessage(new MessageImpl(cc.nom(), buf));
             }
             System.out.println("Bye!");*/

             GUIClient gui = new GUIClientSwing(args[1], cr);
             cc = new ChatClientImpl(args[1], gui); //je passe par paramètres l'interface
             cr.enregistrerClient(cc); // j'enregistre le ChatClient au ChatRoom
             
             //cr.envoyerMessage(new MessageImpl(cc.nom(), ??__??)); // j'ai besoin de lire le JTextField mais je peux pas l'utiliser parce que le composant est dans la classe GUIClientSwing.
             // par ça, je passe par paramètres l'objet ChatRoom à la fenetre "GUIClient" (regarde la ligne 51 du code)
             
        }
        catch(Exception e)
        {
		System.out.println("Erreur de transaction pour " + args[1]);
                 e.printStackTrace();
		System.out.println(e.getMessage());
        }
    }
}
