import java.lang.*;
import java.io.*;

import java.rmi.*;

public class Client {

    public static void main(String args[])
    {
	ChatRoom   cr = null;
	ChatClient cc = null;

	// Analyse des paramètres de la ligne de commande
	if (args.length < 2)
	    {
		System.err.println("Usage:");
		System.err.println("java Client <serveur> <nom_utilisateur>");
		System.exit(1);
	    }

	// Création et installation d'un "security manager".
	System.setSecurityManager(new RMISecurityManager());

	// Obtention d'une référence de la ChatRoom (le serveur)
	try {
	    String url = new String("//"+args[0]+"/ChatRoomGTR");
	    System.out.println("Client: lookup serveur, url = "+url);
	    cr = (ChatRoom)Naming.lookup(url);
	}
	catch (Exception e)
	    {
		System.out.println("Erreur dans l'obtention du serveur"+e);
	    }

	// On effectue quelques lookups
	try {
	    // Creation du client
	    cc = new ChatClientImpl(args[1]);
	    
	    // Enregistrement du client sur le serveur
	    cr.enregistrerClient(cc);

	    // On saisie des chaînes de caractères et on les envoie au serveur
	    BufferedReader in  = new BufferedReader(new InputStreamReader(System.in));
	    String         buf = null;
	    boolean        fin = false;

	    while (!fin)
		{
		    buf = in.readLine();
		    
		    if (buf.equals(""))
			fin = true;
		    else
			cr.envoyerMessage(new MessageImpl(cc.nom(),buf));
		}

	    System.out.println("Bye !");
	}
	catch (Exception e)
	    {
		System.out.println("Erreur de transaction pour "+ args[1]);
                 e.printStackTrace();
		System.out.println(e.getMessage());
	    }

//	System.exit(0);
    }
    
}
